

#define BITMAP_ID 0x4d42

#include "texture.h"



CTexture::CTexture(char *filename)
{

	m_BitmapData = LoadBitmapFile(filename);		//Load bitmap file

	glGenTextures(1, &m_Texture);					//Generate gl texture object
	
	glBindTexture(GL_TEXTURE_2D, m_Texture);		//Bind texture as current drawing texture


			//Set filtering...may move this later
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);


	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, m_BitmapInfoHeader.biWidth, m_BitmapInfoHeader.biHeight, 0, 
				 GL_RGB, GL_UNSIGNED_BYTE, m_BitmapData);




}

CTexture::~CTexture()
{

	//look into cleaning up...not sure about it right now

	
}



unsigned char *CTexture::LoadBitmapFile(char *filename)
{
	
	FILE				*pFile;
	BITMAPFILEHEADER	BitmapFileHeader;
	unsigned char		*BitmapImage;
	int					i = 0;
	unsigned char		RGB;
	unsigned int		iImageSize=0;


	pFile = fopen(filename, "rb");

	if(pFile == NULL)
	{

		return NULL;

	}

	fread(&BitmapFileHeader, sizeof(BITMAPFILEHEADER), 1, pFile);

	if(BitmapFileHeader.bfType!=BITMAP_ID)
	{

		fclose(pFile);
		return NULL;

	}



	fread(&m_BitmapInfoHeader, sizeof(BITMAPINFOHEADER), 1, pFile);

	fseek(pFile, BitmapFileHeader.bfOffBits, SEEK_SET);

	iImageSize = m_BitmapInfoHeader.biWidth*m_BitmapInfoHeader.biHeight*m_BitmapInfoHeader.biBitCount; 

	BitmapImage = (unsigned char*)malloc(iImageSize); //malloc(m_BitmapInfoHeader.biSizeImage);
	//BitmapImage = (unsigned char*)malloc(m_BitmapInfoHeader.biSizeImage);
	//BitmapImage = (unsigned char*)malloc(m_BitmapInfoHeader.biSize);

	if(!BitmapImage)
	{
		
		free(BitmapImage);
		fclose(pFile);
		return NULL;

	}
 

	
	fread(BitmapImage, 1, iImageSize, pFile);
	//fread(BitmapImage, 1, m_BitmapInfoHeader.biSizeImage, pFile);
	//fread(BitmapImage, 1, m_BitmapInfoHeader.biSize, pFile);

	if(BitmapImage == NULL)
	{

		fclose(pFile);
		return NULL;

	}


	//Switch R and B values to get RGB instead of BGR
	//for (i=0;i < m_BitmapInfoHeader.biSizeImage;i+=3)
	for (i=0;i<iImageSize;i+=3)
	//for (i=0;i <  m_BitmapInfoHeader.biSize ;i+=3)
	{

		RGB = BitmapImage[i];
		BitmapImage[i] = BitmapImage[i+2];
		BitmapImage[i+2] = RGB;

	}


	fclose(pFile);

	//free(BitmapImage);

	return BitmapImage;

}
	


void CTexture::ViewBMP()
{
	
	glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
	glRasterPos2i(100,100);
	glDrawPixels(m_BitmapInfoHeader.biWidth, m_BitmapInfoHeader.biHeight, GL_RGB, GL_UNSIGNED_BYTE, m_BitmapData);

}





//Call this when you are ready to use the texture object
void CTexture::Bind()
{

	glBindTexture(GL_TEXTURE_2D, m_Texture);		//Bind texture as current drawing texture

	//Load texture image for drawing
	//glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, m_BitmapInfoHeader.biWidth, m_BitmapInfoHeader.biHeight, 0, 
	//			 GL_RGB, GL_UNSIGNED_BYTE, m_BitmapData);


	
}



/*
//This should go in different class
void CTexture::Initialize()
{

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);			//Clear background to black
	glShadeModel(GL_SMOOTH);						//Use smooth shading
	glEnable(GL_DEPTH_TEST);						//Use hidden surface removal
	glEnable(GL_CULL_FACE);							//Do not calculate inside of polys
	glFrontFace(GL_CCW);							//Counterclockwise polygons are out
	glEnable(GL_TEXTURE_2D);						//Enable 2D texturing


}
*/


